//+----------------------------------------------------------------------------+
//|                                                              i-BalEq2.mq4  |
//|                                                      . aka KimIV  |
//|                                                       http://www.kimiv.ru  |
//|                                                                            |
//|  01.10.2006     .                                      |
//|  23.06.2007     ,    . =Xupypr=  |
//+----------------------------------------------------------------------------+
#property copyright "  . aka KimIV"
#property link      "http://www.kimiv.ru"

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 Lime
#property indicator_width1 2
#property indicator_color2 Red
#property indicator_width2 1

//-------    ----------------------------------------+
extern double Deposit       = 5000.0; //  
extern bool   CurSymbolOnly = false;  //    

//-------   ---------------------------------------------------+
double dBuf0[], dBuf1[];

//-------    ------------------------------------+
int    oob[]; //   
int    oty[]; // 
double olo[]; // 
string osy[]; // 
double oop[]; //  
int    ocb[]; //   
double ocp[]; //  
double osw[]; // 
double opr[]; // 

//+----------------------------------------------------------------------------+
//|  Custom indicator initialization function                                  |
//+----------------------------------------------------------------------------+
void init()
{
 IndicatorDigits(2);
 SetIndexBuffer(0,dBuf0);
 SetIndexLabel (0,"Balance");
 SetIndexStyle (0,DRAW_LINE);
 
 SetIndexBuffer(1,dBuf1);
 SetIndexLabel (1,"Equity");
 SetIndexStyle (1,DRAW_LINE);
}
//+----------------------------------------------------------------------------+
//|  Custom indicator iteration function                                       |
//+----------------------------------------------------------------------------+
void start()
{
 double b,e,p,s,t;
 int    i,j,k;

 ReadDeals();
 if (oob[0]<0) return;
 k=ArraySize(oob);

 for (i=Bars;i>=oob[0];i--)
 {
  dBuf0[i]=EMPTY_VALUE;
  dBuf1[i]=EMPTY_VALUE;
 }
 b=Deposit;
 for (i=oob[0];i>=0;i--)
 {
  e=0;
  for (j=0;j<k;j++)
  {
   if (i==ocb[j] && ocp[j]!=0) b+=osw[j]+opr[j];
   else if (i<=oob[j] && i>=ocb[j])
   {
    p=MarketInfo(osy[j],MODE_POINT);
    s=p*MarketInfo(osy[j],MODE_SPREAD);
    t=NormalizeDouble(TickValue(osy[j],i),2);
    if (t==0) t=10;
    if (p==0) if (StringFind(osy[j],"JPY")<0) p=0.0001; else p=0.01;
    if (oty[j]==OP_BUY) e+=(iClose(osy[j],0,i)-oop[j])/p*olo[j]*t;
    else e+=(oop[j]-iClose(osy[j],0,i)-s)/p*olo[j]*t;
    if (osw[j]!=0) e+=(oob[j]-i)*(osw[j]/(oob[j]-ocb[j]));
   }
  }
  dBuf0[i]=b;
  dBuf1[i]=b+e;
 }
}

//+----------------------------------------------------------------------------+
//|                                                                |
//+----------------------------------------------------------------------------+
void ReadDeals()
{
 ArrayResize(oob,0);
 ArrayResize(oty,0);
 ArrayResize(olo,0);
 ArrayResize(osy,0);
 ArrayResize(oop,0);
 ArrayResize(ocb,0);
 ArrayResize(ocp,0);
 ArrayResize(osw,0);
 ArrayResize(opr,0);
 
 int h=OrdersHistoryTotal(),i,k;

 for (i=0;i<h;i++)
 {
  if (OrderSelect(i,SELECT_BY_POS,MODE_HISTORY))
  {
   if (!CurSymbolOnly || OrderSymbol()==Symbol())
   {
    if (OrderType()==OP_BUY || OrderType()==OP_SELL)
    {
     k=ArraySize(oob);
     ArrayResize(oob,k+1);
     ArrayResize(oty,k+1);
     ArrayResize(olo,k+1);
     ArrayResize(osy,k+1);
     ArrayResize(oop,k+1);
     ArrayResize(ocb,k+1);
     ArrayResize(ocp,k+1);
     ArrayResize(osw,k+1);
     ArrayResize(opr,k+1);
     oob[k]=iBarShift(NULL,0,OrderOpenTime());  //   
     oty[k]=OrderType();                        // 
     olo[k]=OrderLots();                        // 
     osy[k]=OrderSymbol();                      // 
     oop[k]=OrderOpenPrice();                   //  
     ocb[k]=iBarShift(NULL,0,OrderCloseTime()); //   
     ocp[k]=OrderClosePrice();                  //  
     osw[k]=OrderSwap();                        // 
     opr[k]=OrderProfit();                      // 
    }
   }
  }
 }
 h=OrdersTotal();
 for (i=0;i<h;i++)
 {
  if (OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
  {
   if (!CurSymbolOnly || OrderSymbol()==Symbol())
   {
    if (OrderType()==OP_BUY || OrderType()==OP_SELL)
    {
     k=ArraySize(oob);
     ArrayResize(oob,k+1);
     ArrayResize(oty,k+1);
     ArrayResize(olo,k+1);
     ArrayResize(osy,k+1);
     ArrayResize(oop,k+1);
     ArrayResize(ocb,k+1);
     ArrayResize(ocp,k+1);
     ArrayResize(osw,k+1);
     ArrayResize(opr,k+1);
     oob[k]=iBarShift(NULL,0,OrderOpenTime()); //   
     oty[k]=OrderType();                       // 
     olo[k]=OrderLots();                       // 
     osy[k]=OrderSymbol();                     // 
     oop[k]=OrderOpenPrice();                  //  
     ocb[k]=0;                                 //   
     ocp[k]=0;                                 //  
     osw[k]=OrderSwap();                       // 
     opr[k]=OrderProfit();                     // 
    }
   }
  }
 }
}

//+----------------------------------------------------------------------------+
//|                                                  |
//+----------------------------------------------------------------------------+
double TickValue(string symbol, int bar)
{
 double value=MarketInfo(symbol,MODE_TICKVALUE);
 if (StringLen(symbol)!=6) return(value);
 double size=MarketInfo(symbol,MODE_LOTSIZE)*MarketInfo(symbol,MODE_TICKSIZE);
 if (StringSubstr(symbol,3,3)=="USD") return(value);
 else if (StringSubstr(symbol,0,3)=="USD") value=size/iClose(symbol,0,bar);
 else
 {
  string BQ=StringSubstr(symbol,0,3)+"USD";
  if (iClose(BQ,0,0)==0) BQ="USD"+StringSubstr(symbol,0,3);
  if (iClose(BQ,0,0)==0) return(value);
  if (StringSubstr(BQ,0,3)=="USD") value=size/iClose(BQ,0,bar)/iClose(symbol,0,bar);
  else value=size*iClose(BQ,0,bar)/iClose(symbol,0,bar);
 } 
 return(value);
}
//+----------------------------------------------------------------------------+

